VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2880
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3480
   LinkTopic       =   "Form1"
   ScaleHeight     =   2880
   ScaleWidth      =   3480
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton cmdRandomize 
      Caption         =   "Randomize"
      Default         =   -1  'True
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   2280
      Width           =   1215
   End
   Begin VB.Label lblNumbers 
      BorderStyle     =   1  'Fixed Single
      Height          =   2055
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Values() As Integer

Private Const NUM_VALUES = 100
' Quicksort. For details and other sorting algorithms that
' work under different circumstances, see the book
' "Ready-to-Run Visual Basic Algorithms"
' (http://www.vb-helper.com/vba.htm).
Public Sub Quicksort(list() As Integer, ByVal min As Long, ByVal max As Long)
Dim med_value As Long
Dim hi As Long
Dim lo As Long
Dim i As Long

    ' If min >= max, the list contains 0 or 1 items so
    ' it is sorted.
    If min >= max Then Exit Sub

    ' Pick the dividing value.
    i = Int((max - min + 1) * Rnd + min)
    med_value = list(i)

    ' Swap it to the front.
    list(i) = list(min)

    lo = min
    hi = max
    Do
        ' Look down from hi for a value < med_value.
        Do While list(hi) >= med_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            list(lo) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(lo) = list(hi)
        
        ' Look up from lo for a value >= med_value.
        lo = lo + 1
        Do While list(lo) < med_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            list(hi) = med_value
            Exit Do
        End If
        
        ' Swap the lo and hi values.
        list(hi) = list(lo)
    Loop
    
    ' Sort the two sublists.
    Quicksort list(), min, lo - 1
    Quicksort list(), lo + 1, max
End Sub
' Generate and display some random numbers
' between 100 and 999.
Private Sub cmdRandomize_Click()
Dim i As Integer
Dim txt As String

    ReDim Values(1 To NUM_VALUES)
    For i = 1 To NUM_VALUES
        Values(i) = Int(Rnd * 899 + 100)
        txt = txt & Format$(Values(i)) & " "
    Next i
    lblNumbers = txt
End Sub

' Sort the numbers.
Private Sub cmdSort_Click()
Dim i As Integer
Dim txt As String
    
    Quicksort Values, 1, NUM_VALUES

    ' Verify and display the reuslts.
    txt = txt & Format$(Values(1)) & " "
    For i = 2 To NUM_VALUES
        If Values(i) < Values(i - 1) Then Stop
        txt = txt & Format$(Values(i)) & " "
    Next i
    lblNumbers = txt
End Sub

Private Sub Form_Load()
    Randomize
End Sub


